//************************************************************************
//
//      DTOOLS.DCL 
//      Version 1.1    
//      Copyright 1995
//      Byron W. Headrick
//      Sun-Trace Software                    
//                                            
//                                            
//
//
//      LAST REVISION:  1/1/1995
//
//
//
//      THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESSED OR IMPLIED
//      WARRANTY.  ALL IMPLIED WARRANTIES OF FITNESS FOR ANY PARTICULAR
//      PURPOSE AND OF MERCHANTABILITY ARE HEREBY DISCLAIMED.
//
//
//************************************************************************

//dcl_settings : default_dcl_settings { audit_level = 0; }

wrench : dialog {
	   label = "Wrench Clearance";
	   : row {
	     key = "row1";
	     : boxed_radio_column {
		value = "typeW";
		key = "title1";
		label = "Wrench Type";
		: radio_button {
		  key = "Wrench1";
		  label = "Box Wrench";
		  mnemonic = "B";
		  value = "1";
		  }
		: radio_button {
		  key = "Wrench2";
		  label = "Socket Wrench";
		  mnemonic = "S";
		  value = "0";
		  }
		: radio_button {
		  key = "Wrench3";
		  label = "Open End Wrench";
		  mnemonic = "O";
		  value = "0";
		  }}
	     : boxed_column {
		value = "Pic";
		key = "title2";
		: image {
		  key = "Wpic";
		  color = graphics_background;
		  width = 20;
		  aspect_ratio = 0.75;
		  }
	       :row {
		   key = "dimrow1";
		   spacer_1;
		   : text_part {
		     key = "label1";
		     label ="A:  ";
		     width = 5;
		      }
		  : text_part {
		    key = "DimA";
		    width = 5;
		    }}
	       :row {
		   key = "dimrow2";
		   spacer_1;
		   : text_part {
		     key = "label2";
		     label ="B:  ";
		     width = 5;
		      }
		  : text_part {
		    key = "DimB";
		    width = 5;
		    }}}}
	   spacer_1;
	   : row {
	     key = "row3";
	     spacer_1;
	     : popup_list {
		list = "1.00\n.938\n.875\n.812\n.781\n.750\n.688\n.625\n.594\n.562\n.500\n.438\n.375\n.344\n.312\n.250\n.188\n.156";
		value = ".500";
		key = "WSize";
		label = "Wrench Size:";
		mnemonic = "W";
		fixed_width = true;
		width = 4;}
	     spacer_1;
	     }
	   : row {
	     key = "row2";
	     spacer_1;}
	   ok_only;
	   errtile;
	   }



//************************************************************************
//
//      DTOOLS.DCL      Copyright (c) 1994 by DesignTec
//      Version 1.0                           255 Celia St.
//                                            Boaz, AL 35957
//                                            
//
//
//      LAST REVISION:  12-10-94
//
//
//
//
//      LICENSED TO SUN TRACE SOFTWARE FOR USE AND INTEGRATION INTO
//      THEIR SOFTWARE.  UNAUTHORIZED USE OR REPRODUCTION OF THE CONTENTS
//      OF THIS FILE, IN WHOLE OR IN PART, IS STRICTLY PROHIBITED.  ALL
//      RIGHTS RESERVED.
//
//
//
//      THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESSED OR IMPLIED
//      WARRANTY.  ALL IMPLIED WARRANTIES OF FITNESS FOR ANY PARTICULAR
//      PURPOSE AND OF MERCHANTABILITY ARE HEREBY DISCLAIMED.
//
//
//************************************************************************

//dcl_settings : default_dcl_settings { audit_level = 0; }

CON_VERT : dialog {
	label = " English / Metric Conversions ";
	: boxed_row {
	     : boxed_radio_column {
		  key = "from";
		  label = "Convert from:";
		  : radio_button {
		       label = "Inch";
		       mnemonic = "I";
		       key = "from_inch";
		  }
		  : radio_button {
		       label = "Foot";
		       mnemonic = "F";
		       key = "from_foot";
		  }
		  : radio_button {
		       label = "Yard";
		       mnemonic = "Y";
		       key = "from_yard";
		  }
		  : radio_button {
		       label = "Mile";
		       mnemonic = "M";
		       key = "from_mile";
		  }                  
		  : radio_button {
		       label = "Naut. Mile";
		       mnemonic = "N";
		       key = "from_nmile";
		  }                       
		  : radio_button {
		       label = "Millimeter";
		       mnemonic = "L";
		       key = "from_mm";
		  }                    
		  : radio_button {
		       label = "Centimeter";
		       mnemonic = "C";
		       key = "from_cm";
		  }                    
		  : radio_button {
		       label = "Meter";
		       mnemonic = "T";
		       key = "from_meter";
		  }                       
		  : radio_button {
		       label = "Kilometer";
		       mnemonic = "K";
		       key = "from_km";                       
		  }                    
	     }
	     : boxed_radio_column {
		  label = "Convert to:";
		  key = "to";
		  : radio_button {
		       label = "Inch";
		       key = "to_inch";
		  }
		  : radio_button {
		       label = "Foot";
		       key = "to_foot";
		  }
		  : radio_button {
		       label = "Yard";
		       key = "to_yard";
		  }
		  : radio_button {
		       label = "Mile";
		       key = "to_mile";
		  }                  
		  : radio_button {
		       label = "Naut. Mile";
		       key = "to_nmile";
		  }                       
		  : radio_button {
		       label = "Millimeter";
		       key = "to_mm";
		  }                    
		  : radio_button {
		       label = "Centimeter";
		       key = "to_cm";
		  }                    
		  : radio_button {
		       label = "Meter";
		       key = "to_meter";
		  }                       
		  : radio_button {
		       label = "Kilometer";
		       key = "to_km";                       
		  }                    
	     }                       
	}
	: boxed_row {
	     : edit_box {
		  label = "Source Value:";
		  key = "source_value";
		  mnemonic = "S";
	     }
	     : edit_box {
		  label = "Converted Value:";
		  key = "conv_value";
		  Mnemonic = "V";
	     }
	}
	ok_only;
	: text_part {
	     key = "error1";
	     width = 25;
	}
}     
//
//
//
DLEADERS : dialog {
     label = " Interactive Leaders ";
     : row {
       : column  { 
	  : boxed_radio_column {
	       key = "arrow";
	       label = "Arrow:";
	       : radio_button {
		    label = "None";
		    mnemonic = "N";
		    key = "ar_none";
	       }
	       : radio_button {
		    label = "Tic";
		    mnemonic = "T";
		    key = "ar_tic";
	       }                 
	       : radio_button {
		    label = "Architect 1";
		    mnemonic = "A";
		    key = "ar_arc1";
	       }               
	       : radio_button {
		    label = "Architect 2";
		    mnemonic = "R";
		    key = "ar_arc2";
	       }
	       : radio_button {
		    label = "Mechanical";
		    mnemonic = "M";
		    key = "ar_mech";
	       }
	       : radio_button {
		    label = "dot";
		    mnemonic = "D";
		    key = "ar_dot";
	       }
	  }
//          : popup_list {
//               list = "0.20\n0.25\n0.33\n0.40\n0.50\n0.57\n0.67\n0.80\n1.00\n1.25\n1.50\n1.75\n2.00\n2.50\n3.00\n4.00\n5.00\n";
//               value = "1.00";
//               label = "Size";
//               key = "ar_size";
//               fixed_width = true;
//               width = 3;
//         }
       }   
       : column {
	  : boxed_radio_column {
	       key = "text_box";
	       label = "Text Box:";
	       : radio_button {
		    label = "None";
		    mnemonic = "O";
		    key = "tx_none";
	       }
	       : radio_button {
		    label = "Circle";
		    mnemonic = "C";
		    key = "tx_circ";
	       }               
	       : radio_button {
		    label = "Square";
		    mnemonic = "S";
		    key = "tx_sqar";
	       }               
	       : radio_button {
		    label = "Diamond";
		    mnemonic = "I";
		    key = "tx_dmnd";
	       }
	       : radio_button {
		    label = "Hexagon";
		    mnemonic = "H";
		    key = "tx_hex";
	       }
	       : radio_button {
		    label = "Ellipse";
		    mnemonic = "E";
		    key = "tx_elps";
	       }
	  }
//          : popup_list {
//               list = "0.20\n0.25\n0.33\n0.40\n0.50\n0.57\n0.67\n0.80\n1.00\n1.25\n1.50\n1.75\n2.00\n2.50\n3.00\n4.00\n5.00\n";
//               value = "1.00";
//               label = "Size";
//               key = "tx_size";
//               fixed_width = true;
//               width = 3;
//          }
       }
       : column {
	  : image {
	       label = "Example:";
	       key = "image";
	       height = 12;
	       aspect_ratio = 0;
	       color = graphics_background;
	  }
	  : boxed_radio_column {
	       label = "Direction:";
	       key = "direction";
	       : radio_button {
		    label = "From Feature to Text";
		    key = "from_feat";
	       }
	       : radio_button {
		    label = "From Text to Feature";
		    key = "from_txt";
	       }
	  }
       }
    }
    ok_cancel;
}   



