;;;Dynamic Tools=================================================
;;;Version 2.12b
;;;Copyright 1995,1994
;;;Byron W. Headrick
;;;Sun-Trace Software
;;;
;;;Byron W. Headrick - Version 2.12a - 1/18/95
;;;Byron W. Headrick - Version 2.12 - 1/17/95
;;;DesignTec 12/13/94 - Version 2.1
;;;Byron W. Headrick Ver 1.12 - 11/2/94
;;;Byron W. Headrick 1/25/1994 - Original Ver 1.1
;;;
;;;
;;;THESE PROGRAMS ARE PROVIDED "AS IS" AND WITH ALL FAULTS.
;;;IT IS NOT WARRANTED THAT THE OPERATION OF THE PROGRAMS WILL
;;;BE UNINTERRUPTED OR ERROR FREE.
;;;
;;;===========================================================
;;;;***SHAREWARE NOTICE***
(defun BEGIN ( )
 (if ( = "N" STARTVAR)
   (progn
     (princ "\nDYNAMIC TOOLS Ver 2.12b/Copyright 1995/Byron W. Headrick")
     (alert "This is an UNREGISTERED COPY\n of Dynamic Tools Ver 2.12b\n     PLEASE register!\n\n   For more information\n see the file: DTOOLS.DOC")
     (setq STARTVAR "F"))))
;;;===========================================================
;;;***ALERT FOR UNFINISHED FUNCTIONS***
(defun C:DAlrt ()
   (alert "   That function\nis not yet available\nin DTOOLS VER. 2.12b")
   (prin1)
 )
;;;===========================================================
;;;;***REDIFINED COMMADS***
(defun C:END ( )
 (ECHOFF)
 (if (= nil BSe1)
     (setq BSTMP 0))
 (if (= 1 BSTMP)
     (progn
      (princ "\nUpdating Stamp at ENDing...")
      (UDATE)
      (Command "_.CHANGE" BSe1"" "" "" "" "" "" BSTAMP)
      (Command "_.END"))
     (progn
      (princ "\nNo current Stamp defined to update at END.")
      (Command "_.END")))
 (ECHON)
 )
;
(defun C:QSAVE ( )
 (ECHOFF)
 (if (= nil BSe1)
	(setq BSTMP 0))
 (if (= 1 BSTMP)
     (progn
      (princ "\nUpdating Stamp at SAVEing...")
      (UDATE)
      (Command "_.CHANGE" BSe1"" "" "" "" "" "" BSTAMP)
      (Command "_.QSAVE"))
     (progn
      (princ "\nNo current Stamp defined to update at SAVE.")
      (Command "_.QSAVE")))
 (ECHON)
 )
;
(defun C:SAVE ( )
 (ECHOFF)
 (if (= nil BSe1)
       (setq BSTMP 0))
 (if (= 1 BSTMP)
     (progn
      (princ "\nUpdating Stamp at SAVEing...")
      (UDATE)
      (Command "_.CHANGE" BSe1"" "" "" "" "" "" BSTAMP)
      (Command "_.SAVE"))
     (progn
      (princ "\nNo current Stamp defined to update at SAVE.")
      (Command "_.SAVE")))
 (ECHON)
 )
;;;===========================================================
;;;;***COMMON SUB-FUNCTIONS***
(defun GETRAD ( )
 (setq FRAD (getvar "FILLETRAD"))
)
(defun GETCHAM ( )
 (setq CDISTA (getvar "CHAMFERA"))
 (setq CDISTB (getvar "CHAMFERB"))
)
(defun GETLINES ( )
 (setq OBJF1 (entsel "\nFrist line:  "))
 (setq OBJF2 (entsel "\nSecond line:  "))
)
(defun SETRAD ()
 (setvar "FILLETRAD" FRAD)
)
(defun SETCHAM ( )
 (setvar "CHAMFERA" CDISTA)
 (setvar "CHAMFERB" CDISTB)
)
;
(defun DGEN1 (/ USR)
  (setq  USR (getstring "\nShut-off  all automatic screen regenerations Y<N>?  "))
     (setq USR (strcase USR))
     (if (eq  "Y" USR)
	    (progn
	      (Command "REGENAUTO" "OFF")
	(princ "\nUse REGEN for whole screen regenerations or DGEN to regenerate objects")))
	(setq  Dgenvar 1)
)
;
(defun ECHOFF ( )
 (setq CME (getvar "CMDECHO"))
 (setvar "CMDECHO" 0)
)
(defun ECHON ( )  
 (setvar "CMDECHO" CME)
 (prin1)
)
;
(defun UDATE (/ BSNAME YR DY MTH BSDATE BSTIME SLT HR MIN DAY)
 (setq BSNAME (getvar "DWGNAME"))      
 (setq BSDATE (fix (getvar "CDATE")))  
 (setq BSDATE (rtos BSDATE 2))
 (setq YR (substr BSDATE 1 4))
 (setq MTH (substr BSDATE 5 2))
   (setq DY (substr BSDATE 7 2))
   (setq BSDATE (strcat MTH"" "/" DY"" "/" YR""))
 (setq BSTIME (fix (* (- (getvar "CDATE") (fix (getvar "CDATE"))) 10000)))
    (if (< BSTIME 1200)
	    (setq DAY "am")
	    (setq DAY "pm"))
    (if (< BSTIME 60)
	    (setq BSTIME (+ BSTIME 1200)))
    (if (> BSTIME 1259)
	    (setq BSTIME (- BSTIME 1200)))
  (setq BSTIME (itoa BSTIME))
  (setq SLT (strlen BSTIME))
    (setq HR (substr BSTIME 1 (- SLT 2)))
    (setq MIN (substr BSTIME (+ (- SLT 2) 1) 2))
    (setq BSTIME (strcat HR"" ":" MIN"" DAY""))
 (setq BSTAMP(strcat "Filename:" BSNAME"" ".DWG  Date:" BSDATE"" 
  "  Time:" BSTIME"")) 
 )
;
;;;===========================================================
;;;;***STARTUP ROUTINE***
(defun S::STARTUP ()
 (setq CME (getvar "CMDECHO"))
 (setvar "CMDECHO" 0)
 (Command "UNDEFINE" "SAVE")
 (Command "UNDEFINE" "QSAVE")
 (Command "UNDEFINE" "END")
 (setvar "CMDECHO" CME)
)
;
(defun C:Normal (/ USR OBJ OBJ1 PT1 PT2 ANG1)
 (ECHOFF)
 (BEGIN)
 (princ "\nNormal -")
 (setq USR (getangle "\nEnter Angle or <ENTER> to match line entity>:  "))
 (if USR
  (setvar "SNAPANG" USR))
 (if (eq nil USR)
   (progn
   (setq OBJ (nentsel "\nSelect line entity with desired angle to match:  "))
   (setq OBJ1 (entget (car OBJ)))
   (setq PT1 (cdr (assoc 10 OBJ1)))
   (setq PT2 (cdr (assoc 11 OBJ1)))
   (setq ANG1 (angle PT1 PT2))
   (setvar "SNAPANG" ANG1)))
 (ECHON)
)
;
(defun C:Surf2 (/ PT1)
 (ECHOFF)
 (BEGIN)
 (princ "\nSurface Finish 2 -")
 (setq PT1 (getpoint "\nSELECT LOCATION POINT:  "))
 (Command "_.INSERT" "DT_SF2" PT1 pause pause pause)
 (ECHON)
)
;
(defun C:Surf4 (/ PT1)
 (ECHOFF)
 (BEGIN)
 (princ "\nSurface Finish 4 -")
 (setq PT1 (getpoint "\nSELECT LOCATION POINT:  "))
 (Command "_.INSERT" "DT_SF4" PT1 pause pause pause)
 (ECHON)
)
;
(defun C:Surf8 (/ PT1)
 (ECHOFF)
 (BEGIN)
 (princ "\nSurface Finish 8 -")
 (setq PT1 (getpoint "\nSELECT LOCATION POINT:  "))
 (Command "_.INSERT" "DT_SF8" PT1 pause pause pause)
 (ECHON)
)
;
(defun C:Surf16 (/ PT1)
 (ECHOFF)
 (BEGIN)
 (princ "\nSurface Finish 16 -")
 (setq PT1 (getpoint "\nSELECT LOCATION POINT:  "))
 (Command "_.INSERT" "DT_SF16" PT1 pause pause pause)
 (ECHON)
)
;
(defun C:Surf32 (/ PT1)
 (ECHOFF)
 (BEGIN)
 (princ "\nSurface Finish 32 -")
 (setq PT1 (getpoint "\nSELECT LOCATION POINT:  "))
 (Command "_.INSERT" "DT_SF32" PT1 pause pause pause)
 (ECHON)
)
;
(defun C:Surf63 (/ PT1)
 (ECHOFF)
 (BEGIN)
 (princ "\nSurface Finish 63 -")
 (setq PT1 (getpoint "\nSELECT LOCATION POINT:  "))
 (Command "_.INSERT" "DT_SF63" PT1 pause pause pause)
 (ECHON)
)
;
(defun C:Surf125 (/ PT1)
 (ECHOFF)
 (BEGIN)
 (princ "\nSurface Finish 125 -")
 (setq PT1 (getpoint "\nSELECT LOCATION POINT:  "))
 (Command "_.INSERT" "DT_SF125" PT1 pause pause pause)
 (ECHON)
)
;
(defun C:SurfSTK (/ PT1)
 (ECHOFF)
 (BEGIN)
 (princ "\nSurface Finish STK -")
 (setq PT1 (getpoint "\nSELECT LOCATION POINT:  "))
 (Command "_.INSERT" "DT_SFSTK" PT1 pause pause pause)
 (ECHON)
)
;
(defun C:R031 ( )
 (ECHOFF)
 (BEGIN)
 (princ "\n.0312 FILLET -")
 (GETRAD)
 (setvar "FILLETRAD" 0.0312)
 (GETLINES)
 (Command "_.Fillet" OBJF1 OBJF2)
 (SETRAD)
 (ECHON)
)
;
(defun C:R062 ( )
 (ECHOFF)
 (BEGIN)
 (princ "\n.0625 FILLET -")
 (GETRAD)
 (setvar "FILLETRAD" 0.0625)
 (GETLINES)
 (Command "_.Fillet" OBJF1 OBJF2)
 (SETRAD)
 (ECHON)
)
;
(defun C:R125 ( )
 (ECHOFF)
 (BEGIN)
 (princ "\n.125 FILLET -")
 (GETRAD)
 (setvar "FILLETRAD" 0.125)
 (GETLINES)
 (Command "_.Fillet" OBJF1 OBJF2)
 (SETRAD)
 (ECHON)
)
;
(defun C:R250 ( )
 (ECHOFF)
 (BEGIN)
 (princ "\n.250 FILLET -")
 (GETRAD)
 (setvar "FILLETRAD" 0.250)
 (GETLINES)
 (Command "_.Fillet" OBJF1 OBJF2)
 (SETRAD)
 (ECHON)
)
;
(defun C:R375 ( )
 (ECHOFF)
 (BEGIN)
 (princ "\n.375 FILLET -")
 (GETRAD)
 (setvar "FILLETRAD" 0.375)
 (GETLINES)
 (Command "_.Fillet" OBJF1 OBJF2)
 (SETRAD)
 (ECHON)
)
;
(defun C:R500 ( )
 (ECHOFF)
 (BEGIN)
 (princ "\n.500 FILLET -")
 (GETRAD)
 (setvar "FILLETRAD" 0.500)
 (GETLINES)
 (Command "_.Fillet" OBJF1 OBJF2)
 (SETRAD)
 (ECHON)
)
;
(defun C:R625 ( )
 (ECHOFF)
 (BEGIN)
 (princ "\n.625 FILLET -")
 (GETRAD)
 (setvar "FILLETRAD" 0.625)
 (GETLINES)
 (Command "_.Fillet" OBJF1 OBJF2)
 (SETRAD)
 (ECHON)
)
;
(defun C:R750 ( )
 (ECHOFF)
 (BEGIN)
 (princ "\n.750 FILLET -")
 (GETRAD)
 (setvar "FILLETRAD" 0.750)
 (GETLINES)
 (Command "_.Fillet" OBJF1 OBJF2)
 (SETRAD)
 (ECHON)
)
;
(defun C:R875 ( )
 (ECHOFF)
 (BEGIN)
 (princ "\n.875 FILLET -")
 (GETRAD)
 (setvar "FILLETRAD" 0.875)
 (GETLINES)
 (Command "_.Fillet" OBJF1 OBJF2)
 (SETRAD)
 (ECHON)
)
;
(defun C:R100 ( )
 (ECHOFF)
 (BEGIN)
 (princ "\n1.00 FILLET -")
 (GETRAD)
 (setvar "FILLETRAD" 1)
 (GETLINES)
 (Command "_.Fillet" OBJF1 OBJF2)
 (SETRAD)
 (setvar "CMDECHO" CME)
 (ECHON)
)
;
(defun C:C031 ( )
 (ECHOFF)
 (BEGIN)
 (princ "\n.0312 CHAMFER -")
 (GETCHAM)
 (setvar "CHAMFERA" 0.0312)
 (setvar "CHAMFERB" 0.0312)
 (GETLINES)
 (Command "_.CHAMFER" OBJF1 OBJF2)
 (SETCHAM)
 (ECHON)
)
;
(defun C:C062 (/ CME)
 (ECHOFF)
 (BEGIN)
 (princ "\n.0625 CHAMFER -")
 (GETCHAM)
 (setvar "CHAMFERA" 0.0625)
 (setvar "CHAMFERB" 0.0625)
 (GETLINES)
 (Command "_.CHAMFER" OBJF1 OBJF2)
 (SETCHAM)
 (ECHON)
)
;
(defun C:C125 ( )
 (ECHOFF)
 (BEGIN)
 (princ "\n.125 CHAMFER -")
 (GETCHAM)
 (setvar "CHAMFERA" 0.125)
 (setvar "CHAMFERB" 0.125)
 (GETLINES)
 (Command "_.CHAMFER" OBJF1 OBJF2)
 (SETCHAM)
 (ECHON)
)
;
(defun C:C250 ( )
 (ECHOFF)
 (BEGIN)
 (princ "\n.250 CHAMFER -")
 (GETCHAM)
 (setvar "CHAMFERA" 0.250)
 (setvar "CHAMFERB" 0.250)
 (GETLINES)
 (Command "_.CHAMFER" OBJF1 OBJF2)
 (SETCHAM)
 (ECHON)
)
;
(defun C:C375 ( )
 (ECHOFF)
 (BEGIN)
 (princ "\n.375 CHAMFER -")
 (GETCHAM)
 (setvar "CHAMFERA" 0.375)
 (setvar "CHAMFERB" 0.375)
 (GETLINES)
 (Command "_.CHAMFER" OBJF1 OBJF2)
 (ECHON)
 (prin1)
)
;
(defun C:C500 ( )
 (ECHOFF)
 (BEGIN)
 (princ "\n.500 CHAMFER -")
 (GETCHAM)
 (setvar "CHAMFERA" 0.500)
 (setvar "CHAMFERB" 0.500)
 (GETLINES)
 (Command "_.CHAMFER" OBJF1 OBJF2)
 (ECHON)
)
;
(defun C:C625 ( )
 (ECHOFF)
 (BEGIN)
 (princ "\n.625 CHAMFER -")
 (GETCHAM)
 (setvar "CHAMFERA" 0.625)
 (setvar "CHAMFERB" 0.625)
 (GETLINES)
 (Command "_.CHAMFER" OBJF1 OBJF2)
 (SETCHAM)
 (ECHON)
)
;
(defun C:C750 ( )
 (ECHOFF)
 (BEGIN)
 (princ "\n.750 CHAMFER -")
 (GETCHAM)
 (setvar "CHAMFERA" 0.750)
 (setvar "CHAMFERB" 0.750)
 (GETLINES)
 (Command "_.CHAMFER" OBJF1 OBJF2)
 (SETCHAM)
 (ECHON)
)
;
(defun C:C875 ( )
 (ECHOFF)
 (BEGIN)
 (princ "\n.875 CHAMFER -")
 (GETCHAM)
 (setvar "CHAMFERA" 0.875)
 (setvar "CHAMFERB" 0.875)
 (GETLINES)
 (Command "_.CHAMFER" OBJF1 OBJF2)
 (SETCHAM)
 (ECHON)
)
;
(defun C:C100 ( )
 (ECHOFF)
 (BEGIN)
 (princ "\n1.00 CHAMFER -")
 (GETCHAM)
 (setvar "CHAMFERA" 1)
 (setvar "CHAMFERB" 1)
 (GETLINES)
 (Command "_.CHAMFER" OBJF1 OBJF2)
 (SETCHAM)
 (ECHON)
)
;
(defun C:Dgen (/ CNT ENT OBJ OBJL)
 (ECHOFF)
 (BEGIN)
(if (= nil Dgenvar)
     (DGEN1))
(princ "\nDGEN  - ")
 (setq OBJ (ssget))
 (setq OBJL (sslength OBJ)) 
 (setq CNT 0)
 (while (< CNT OBJL)
    (setq ENT (ssname OBJ CNT))
    (entupd ENT)
    (setq CNT (1+ CNT))
   )
 (setvar "CMDECHO" CME)
 (ECHON)
 )
;
 (defun C:Same (/ OBJ1 LT LY CLR SELST1)
 (ECHOFF)
 (BEGIN)
 (princ "\nSAME -")
 (princ"\nLEAD ENTITY - ")
 (setq OBJ1 (car (entsel "\nSelect Entity:  ")))
 (setq OBJ1 (entget OBJ1))
 (setq 
  LT (cdr (assoc 6 OBJ1))
  LY (cdr (assoc 8 OBJ1))
  CLR (cdr (assoc 62 OBJ1)))
 (if LT (princ) (setq LT (strcat "BYLAYER")))
 (if CLR (princ) (setq CLR (strcat "BYLAYER")))
 (princ "\nOBJECTS TO MAKE SAME - ")
 (setq SELST1 (ssget))
 (Command "_.CHPROP" SELST1 "" "C" CLR "LA" LY "LT" LT "")
 (ECHON)
)
;
 (defun C:PStmp (/ txtsize Sfactor)
 (ECHOFF)
 (BEGIN)
 (princ "\nPRELIMINARYstamp -")
 (setq txtsize (getreal "\nENTER TEXT SIZE:  "))
 (setq Sfactor (/ txtsize 0.25))
 (setq PT1 (getpoint "\nSELECT LOCATION POINT:  "))
 (princ "\nROTATION ANGLE <0>:  ")
 (Command "_.INSERT" "DT_PRE" PT1 Sfactor "" pause)
 (ECHON)
)
;
 (defun C:RStmp (/ txtsize Sfactor)
 (ECHOFF)
 (BEGIN)
 (princ "\nREDUCEDstamp -")
 (setq txtsize (getreal "\nENTER TEXT SIZE:  "))
 (setq Sfactor (/ txtsize 0.25))
 (setq PT1 (getpoint "\nSELECT LOCATION POINT:  "))
 (princ "\nROTATION ANGLE <0>:  ")
 (Command "_.INSERT" "DT_RED" PT1 Sfactor "" pause)
 (ECHON)
)
;
 (defun C:Scale14 ( )
 (ECHOFF)
 (BEGIN)
 (Command "_.DIM" "_.DIMASZ" ".64")
 (Command "_.DIM" "_.DIMEXO" ".24")
 (Command "_.DIM" "_.DIMEXE" ".24")
 (Command "_.DIM" "_.DIMTXT" ".64" ^C ^C^C)
 (Command "_.REDRAW")
 (princ "\n SCALE set to 1/4")
 (ECHON)
)
;
(defun C:Scale12 ( )
 (ECHOFF)
 (BEGIN)
 (Command "_.DIM" "_.DIMASZ" ".32")
 (Command "_.DIM" "_.DIMEXO" ".16")
 (Command "_.DIM" "_.DIMEXE" ".16")
 (Command "_.DIM" "_.DIMTXT" ".32" ^C ^C^C)
 (Command "_.REDRAW")
 (princ "\n SCALE set to 1/2")
 (ECHON)
)
;
(defun C:Scale13 ( )
 (ECHOFF)
 (BEGIN)
 (Command "_.DIM" "_.DIMASZ" ".48")
 (Command "_.DIM" "_.DIMEXO" ".24")
 (Command "_.DIM" "_.DIMEXE" ".24")
 (Command "_.DIM" "_.DIMTXT" ".48" ^C ^C^C)
 (Command "_.REDRAW")
 (princ "\n SCALE set to 1/3")
 (ECHON)
)
;
 (defun C:Scale11 ( )
 (ECHOFF)
 (BEGIN)
 (Command "_.DIM" "_.DIMASZ" ".16")
 (Command "_.DIM" "_.DIMEXO" ".08")
 (Command "_.DIM" "_.DIMEXE" ".08")
 (Command "_.DIM" "_.DIMTXT" ".16" ^C ^C^C)
 (Command "_.REDRAW")
 (princ "\n SCALE set to 1/1")
 (ECHON)
)
;
(defun C:Scale31 ( )
 (ECHOFF)
 (BEGIN)
 (Command "_.DIM" "_.DIMASZ" ".0533")
 (Command "_.DIM" "_.DIMEXO" ".0266")
 (Command "_.DIM" "_.DIMEXE" ".0266")
 (Command "_.DIM" "_.DIMTXT" ".0533" ^C ^C^C)
 (Command "_.REDRAW")
 (princ "\n SCALE set to 3/1")
 (ECHON)
)
;
(defun C:Scale21 ( )
 (ECHOFF)
 (BEGIN)
 (Command "_.DIM" "_.DIMASZ" ".08")
 (Command "_.DIM" "_.DIMEXO" ".04")
 (Command "_.DIM" "_.DIMEXE" ".04")
 (Command "_.DIM" "_.DIMTXT" ".08" ^C ^C^C)
 (Command "_.REDRAW")
 (princ "\n SCALE set to 2/1")
 (ECHON)
)
;
(defun C:Scale41 ( )
 (ECHOFF)
 (BEGIN)
 (Command "_.DIM" "_.DIMASZ" ".04")
 (Command "_.DIM" "_.DIMEXO" ".02")
 (Command "_.DIM" "_.DIMEXE" ".02")
 (Command "_.DIM" "_.DIMTXT" ".04" ^C ^C^C)
 (Command "_.REDRAW")
 (princ "\n SCALE set to 4/1")
 (ECHON)
)
;
(defun C:CScale (/ SELST1 BPT LPT)
 (ECHOFF)
 (BEGIN)
 (princ "\nSCALEcopy")
 (setq SELST1 (ssget))
 (setq BPT (getpoint "\nFROM POINT(BASE POINT):  "))
 (setq LPT (getpoint "\nTO POINT(LOCATION POINT):  "))
 (princ "\n<SCALE FACTOR>/REFERENCE:  ")
 (Command "_.COPY" "P" "" BPT BPT)
 (Command "_.MOVE" "P" "" BPT LPT)
 (Command "_.SCALE" "P" "" LPT PAUSE)
 (Command "_.REDRAW")
 (ECHON)
)
;
(defun C:CRotate (/ SELST1 RPT ANG)
 (ECHOFF)
 (BEGIN)
 (princ "\nROTATEcopy")
 (setq SELST1 (ssget))
 (setq RPT (getpoint "\nBASE POINT:  "))
 (princ "\n<ROTATION ANGLE>/REFERENCE:")
 (Command "_.COPY" "P" "" RPT RPT)
 (Command "_.ROTATE" "P" "" RPT Pause)
 (Command "_.REDRAW")
 (ECHON)
)
;
(defun C:Lrotate (/ OBJ obj1 pt1 pt2 SELST1 BPT USR)
 (ECHOFF)
 (BEGIN)
 (princ "\nROTATElike - ")
 (setq OBJ (entsel "\nSelect Line entity with angle to match:  "))
 (setq obj1 (entget (car OBJ)))
 (setq pt1 (cdr (assoc 10 obj1)))
 (setq pt2 (cdr (assoc 11 obj1)))
 (setq ANG1 (angle pt1 pt2))
 (setq ANG2 (angtos ANG1 0 4))
 (princ "\nHorizontal Objects to Rotate:  ")
 (setq BPT (getpoint "\nSelect base point of rotation:  "))
 (Command  "_.ROTATE" SELST1 "" BPT ANG2 "")
 (ECHON)
)
;
(defun C:LENGTH (/ OBJ obj1 pt1 pt2 LGTH PROMP ER)
 (ECHOFF)
 (BEGIN)
 (princ "\nLENGTH of line - ")
 (setq OBJ (entsel "\nSelect Line to Measure:  "))
 (setq obj1 (entget (car OBJ)))
 (setq pt1 (cdr (assoc 10 obj1)))
 (setq pt2 (cdr (assoc 11 obj1)))
 (setq LGTH (distance pt1 pt2))
 (setq LGTH (rtos LGTH))
 (setq PROMP (strcat "\nLine Length:  " LGTH""))
 (princ PROMP)
 (ECHON)
)
;
(defun C:filletNT (/ USR CRAD OPROMP RAD OBJF Fobj1 Fobj2 Fpt1 Fpt2 
		   FA OBJS Sobj1 Sobj2 Spt1 Spt2 SA ORTH)
 (ECHOFF)
 (BEGIN)
 (setq ORTH (getvar "ORTHOMODE"))
 (setq CRAD (getvar "FILLETRAD"))
 (setq CRAD (rtos CRAD))
 (princ "\nFILLET - No Trim")
 (setq OPROMP (strcat "\nCurrent fillet radius - " CRAD""))
 (princ OPROMP)
 (setq USR (getstring "\nChange fillet radius Y<N>? "))
   (setq USR (strcase USR))
     (if (eq "Y" USR)
	   (progn
	    (setq RAD (getreal "\nEnter new fillet radius: "))
	    (Command "_.Fillet" "R" RAD)))
 (princ "\nFirst Object of Fillet")           
  (setq OBJF (entsel))
  (setq Fobj1 (entget (car OBJF)))
  (setq Fobj2 (cadr OBJF))
  (setq Fpt1 (cdr (assoc 10 Fobj1)))
  (setq Fpt2 (cdr (assoc 11 Fobj1)))
  (setq FA (angle Fpt1 Fpt2))
 (princ "\nSecond Object of Fillet")
  (setq OBJS (entsel))
  (setq Sobj1 (entget (car OBJS)))
  (setq Sobj2 (cadr OBJS))
  (setq Spt1 (cdr (assoc 10 Sobj1)))
  (setq Spt2 (cdr (assoc 11 Sobj1)))
  (setq SA (angle Spt1 Spt2))
 (Command "_.FILLET" OBJF OBJS)
 (Command "_.ERASE" OBJF"")
 (Command "_.ERASE" OBJS"")
 (setvar "ORTHOMODE" 1)
 (setvar "SNAPANG" FA)
 (Command "_.LINE" Fpt1 Fpt2"")
 (setvar "SNAPANG" SA)
 (Command "_.LINE" Spt1 Spt2"")
 (setvar "ORTHOMODE" ORTH)
 (setvar "SNAPANG" 0)
 (setq OBJF nil)
 (setq OBJS nil)
 (ECHON)
 )
;
(defun C:chamferNT (/ USR OBJF Fobj1 Fobj2 Fpt1 Fpt2 
		   FA OBJS Sobj1 Sobj2 Spt1 Spt2 SA ORTH)
 (ECHOFF)
 (BEGIN)
 (setq ORTH (getvar "ORTHOMODE"))
 (princ "\nCHAMFER - No Trim")
 (princ "\nFirst Object of Chamfer:  ")           
  (setq OBJF (entsel))
  (setq Fobj1 (entget (car OBJF)))
  (setq Fobj2 (cadr OBJF))
  (setq Fpt1 (cdr (assoc 10 Fobj1)))
  (setq Fpt2 (cdr (assoc 11 Fobj1)))
  (setq FA (angle Fpt1 Fpt2))
 (princ "\nSecond Object of CHAMFER")
  (setq OBJS (entsel))
  (setq Sobj1 (entget (car OBJS)))
  (setq Sobj2 (cadr OBJS))
  (setq Spt1 (cdr (assoc 10 Sobj1)))
  (setq Spt2 (cdr (assoc 11 Sobj1)))
  (setq SA (angle Spt1 Spt2))
 (Command "_.CHAMFER" OBJF OBJS)
 (Command "_.ERASE" OBJF"")
 (Command "_.ERASE" OBJS"")
 (setvar "ORTHOMODE" 1)
 (setvar "SNAPANG" FA)
 (Command "_.LINE" Fpt1 Fpt2"")
 (setvar "SNAPANG" SA)
 (Command "_.LINE" Spt1 Spt2"")
 (setvar "ORTHOMODE" ORTH)
 (setvar "SNAPANG" 0)
 (setq OBJF nil)
 (setq OBJS nil)
 (ECHON)
 )
;
(defun C:LTrim (/ fOPT OPT OBJ obj1 obj2 PT pt1 pt2 OPT1D OPT2D)
 (ECHOFF)
 (BEGIN)
 (princ "\nLineTRIM")
 (setq OBJ (entsel "\nSelect Line to trim: "))
 (setq fOPT (getpoint "\nSelect end of line to keep: "))
 (setq OPT (osnap fOPT "endp"))
 (setq obj1 (entget (car OBJ)))
 (setq obj2 (cadr OBJ))
 (setq pt1 (cdr (assoc 10 obj1)))
 (setq pt2 (cdr (assoc 11 obj1)))
 (setq OPT1D (distance pt1 OPT))
 (setq OPT2D (distance pt2 OPT))
 (setq PT (getpoint "\nSelect point to trim to:  "))
 (if (< OPT1D OPT2D) (Command "_.BREAK" OBJ "F" PT pt2))
 (if (< OPT2D OPT1D) (Command "_.BREAK" OBJ "F" PT pt1))
 (ECHON)
)
;
(defun C:BSupdate ( )
  (ECHOFF)
  (BEGIN)
  (princ)
  (princ "\nStamp-Update")
  (if (= nil BSe1)
	 (progn
	  (alert "No current stamp defined.")
	  (setq BSe1 (entsel "\nSelect current stamp definition: "))
	  (setq BSTMP 1)
	  (UDATE)
	  (Command "_.CHANGE" BSe1"" "" "" "" "" "" BSTAMP))
	 (progn
	  (UDATE)
	  (Command "_.CHANGE" BSe1"" "" "" "" "" "" BSTAMP))) 
  (ECHON)
 )
;
(defun C:StmpON (/ BSTXT BSpt1 BSNAME YR DY MTH 
		   BSDATE BSTIME SLT HR MIN DAY)
 (ECHOFF)
 (BEGIN)
 (princ)
 (princ "\nStamp-ON")
 (setq BSpt1 (getpoint "\nEnter point of Stamp placement: "))
 (setq BSTXT (getreal "\nEnter Stamp text height: "))
 (setq BSTMP 1)
 (setq BSNAME (getvar "DWGNAME"))      
 (setq BSDATE (fix (getvar "CDATE")))  
 (setq BSDATE (rtos BSDATE 2))
   (setq YR (substr BSDATE 1 4))
   (setq MTH (substr BSDATE 5 2))
   (setq DY (substr BSDATE 7 2))
   (setq BSDATE (strcat MTH"" "/" DY"" "/" YR""))
 (setq BSTIME (fix (* (- (getvar "CDATE") (fix (getvar "CDATE"))) 10000)))
    (if (< BSTIME 1200)
	    (setq DAY "am")
	    (setq DAY "pm"))
    (if (< BSTIME 60)
	    (setq BSTIME (+ BSTIME 1200)))
    (if (> BSTIME 1259)
	    (setq BSTIME (- BSTIME 1200)))
  (setq BSTIME (itoa BSTIME))
  (setq SLT (strlen BSTIME))
    (setq HR (substr BSTIME 1 (- SLT 2)))
    (setq MIN (substr BSTIME (+ (- SLT 2) 1) 2))
    (setq BSTIME (strcat HR"" ":" MIN"" DAY""))
 (setq BSTAMP(strcat "Filename:" BSNAME"" ".DWG  Date:" BSDATE"" 
	      "  Time:" BSTIME"")) 
 (Command "TEXT" BSpt1 BSTXT "0" BSTAMP)
 (setq BSe1 (entlast))
 (ECHON)
 )
;
(defun C:Dup (/ CENT)
 (ECHOFF)
 (BEGIN)
 (princ "\nDUPLICATE")
 (Command "_.LAYER" "N" "DUPLICATE" ^C)
 (setq CENT (ssget))
 (Command "_.COPY" CENT"" "0,0" "0,0")
 (Command "_.CHPROP" CENT"" "LA"  "DUPLICATE" "")
 (Command "_.LAYER" "OFF" "DUPLICATE" ^C)
 (Command "_.REDRAW")
 (setq CENT nil)
 (princ "\nTurn layer DUPLICATE on to view copy.")
 (ECHON)
)
;
(defun C:ExtIntr (/ CRAD OBJF OBJS)
 (ECHOFF)
 (BEGIN)
 (setq CRAD (getvar "FILLETRAD"))
 (princ "\nExtend Lines to Intersection")
 (setq OBJF (entsel "\nFirst Line: "))
 (setq OBJS (entsel "\nSecond Line: "))
 (setvar "FILLETRAD" 0)
 (Command "_.FILLET" OBJF OBJS)
 (setvar "FILLETRAD" CRAD)
 (ECHON)
)
;
(defun C:WRENCHC ( / dcl_id)
  (BEGIN)
  (setq dcl_id (load_dialog "dtools.dcl"))
  (if (not (new_dialog "wrench" dcl_id))
    (exit))
  (setq x (dimx_tile "Wpic")
       y (dimy_tile "Wpic"))
  (start_image "Wpic")
  (slide_image 0 0 x y "box")
  (end_image)
  (set_tile "DimA" ".810")
  (set_tile "DimB" "-")
  (set_tile "WSize" "0")
  (setq Wtype "B")
;;;***Main
  (action_tile "Wrench1" "(do_box)")
  (action_tile "Wrench2" "(do_socket)")
  (action_tile "Wrench3" "(do_open)")

  (defun do_box ( )  ;;Sub-function for Box Wrench data
   (setq Wtype "B")
   (setq x (dimx_tile "Wpic")
	 y (dimy_tile "Wpic"))
   (start_image "Wpic")
   (fill_image 0 0 x y -2)
   (slide_image 0 0 x y "box")
   (end_image)
   (do_size)
   )

  (defun do_socket ( ) ;;Sub-function for Socket Wrench data
   (setq Wtype "S")
   (setq x (dimx_tile "Wpic")
	 y (dimy_tile "Wpic"))
   (start_image "Wpic")
   (fill_image 0 0 x y -2)
   (slide_image 0 0 x y "socket")
   (end_image)
   (do_size)
   )

  (defun do_open ( ) ;;Sub-function for Open End Wrench data
   (setq Wtype "O")
   (setq x (dimx_tile "Wpic")
	 y (dimy_tile "Wpic"))
   (start_image "Wpic")
   (fill_image 0 0 x y -2)
   (slide_image 0 0 x y "open")
   (end_image)
   (do_size)
   )

  (action_tile "WSize" "(do_size)")

  (defun do_size ( ) ;;Sub-function for Wrench Size
   (setq WSZ (get_tile "WSize"))
   (if
     (= 0 (atoi WSZ))
     (progn
	(if ( = "B"  Wtype) 
	    (do_B1))
	(if ( = "S" Wtype)
	    (do_S1))
	(if (= "O" Wtype)
	    (do_O1))))
   (if
     (= 1 (atoi WSZ))
     (progn
	(if ( = "B"  Wtype) 
	    (do_B938))
	(if ( = "S" Wtype)
	    (do_S938))
	(if (= "O" Wtype)
	    (do_O938))))
   (if
     (= 2 (atoi WSZ))
     (progn
	(if ( = "B"  Wtype) 
	    (do_B875))
	(if ( = "S" Wtype)
	    (do_S875))
	(if (= "O" Wtype)
	    (do_O875))))
   (if
     (= 3 (atoi WSZ))
     (progn
	(if ( = "B"  Wtype) 
	    (do_B812))
	(if ( = "S" Wtype)
	    (do_S812))
	(if (= "O" Wtype)
	    (do_O812))))
   (if
     (= 4 (atoi WSZ))
     (progn
	(if ( = "B"  Wtype) 
	    (do_B781))
	(if ( = "S" Wtype)
	    (do_S781))
	(if (= "O" Wtype)
	    (do_O781))))
   (if
     (= 5 (atoi WSZ))
     (progn
	(if ( = "B"  Wtype) 
	    (do_B75))
	(if ( = "S" Wtype)
	    (do_S75))
	(if (= "O" Wtype)
	    (do_O75))))
   (if
     (= 6 (atoi WSZ))
     (progn
	(if ( = "B"  Wtype) 
	    (do_B688))
	(if ( = "S" Wtype)
	    (do_S688))
	(if (= "O" Wtype)
	    (do_O688))))
   (if
     (= 7 (atoi WSZ))
     (progn
	(if ( = "B"  Wtype) 
	    (do_B625))
	(if ( = "S" Wtype)
	    (do_S625))
	(if (= "O" Wtype)
	    (do_O625))))
   (if
     (= 8 (atoi WSZ))
     (progn
	(if ( = "B"  Wtype) 
	    (do_B594))
	(if ( = "S" Wtype)
	    (do_S594))
	(if (= "O" Wtype)
	    (do_O594))))
   (if
     (= 9 (atoi WSZ))
     (progn
	(if ( = "B"  Wtype) 
	    (do_B562))
	(if ( = "S" Wtype)
	    (do_S562))
	(if (= "O" Wtype)
	    (do_O562))))
   (if
     (= 10 (atoi WSZ))
     (progn
	(if ( = "B"  Wtype) 
	    (do_B5))
	(if ( = "S" Wtype)
	    (do_S5))
	(if (= "O" Wtype)
	    (do_O5))))
   (if
     (= 11 (atoi WSZ))
     (progn
	(if ( = "B"  Wtype) 
	    (do_B438))
	(if ( = "S" Wtype)
	    (do_S438))
	(if (= "O" Wtype)
	    (do_O438))))
   (if
     (= 12 (atoi WSZ))
     (progn
	(if ( = "B"  Wtype) 
	    (do_B375))
	(if ( = "S" Wtype)
	    (do_S375))
	(if (= "O" Wtype)
	    (do_O375))))
   (if
     (= 13 (atoi WSZ))
     (progn
	(if ( = "B"  Wtype) 
	    (do_B344))
	(if ( = "S" Wtype)
	    (do_S344))
	(if (= "O" Wtype)
	    (do_O344))))
   (if
     (= 14 (atoi WSZ))
     (progn
	(if ( = "B"  Wtype) 
	    (do_B312))
	(if ( = "S" Wtype)
	    (do_S312))
	(if (= "O" Wtype)
	    (do_O312))))
   (if
     (= 15 (atoi WSZ))
     (progn
	(if ( = "B"  Wtype) 
	    (do_B25))
	(if ( = "S" Wtype)
	    (do_S25))
	(if (= "O" Wtype)
	    (do_O25))))
   (if
     (= 16 (atoi WSZ))
     (progn
	(if ( = "B"  Wtype) 
	    (do_B188))
	(if ( = "S" Wtype)
	    (do_S188))
	(if (= "O" Wtype)
	    (do_O188))))
   (if
     (= 17 (atoi WSZ))
     (progn
	(if ( = "B"  Wtype) 
	    (do_B156))
	(if ( = "S" Wtype)
	    (do_S156))
	(if (= "O" Wtype)
	    (do_O156))))
)
  (defun do_B156 ( )
   (mode_tile "label1" 0)
   (mode_tile "label2" 0)
   (mode_tile "DimA" 0)   
   (set_tile "DimA" ".190")
   (mode_tile "DimB" 0)
   (set_tile "DimB" ".280"))

  (defun do_S156 ( )
   (mode_tile "label1" 1)
   (mode_tile "label2" 0)
   (set_tile "DimA" "-")
   (mode_tile "DimA" 1)
   (mode_tile "DimB" 0)
   (set_tile "DimB" "-"))

  (defun do_O156 ( )
   (mode_tile "label1" 0)
   (mode_tile "label2" 1)
   (mode_tile "DimA" 0)
   (set_tile "DimA" ".220")
   (set_tile "DimB" "-")
   (mode_tile "DimB" 1))


  (defun do_B188 ( )
   (mode_tile "label1" 0)
   (mode_tile "label2" 0)
   (mode_tile "DimA" 0)   
   (set_tile "DimA" ".200")
   (mode_tile "DimB" 0)
   (set_tile "DimB" ".309"))

  (defun do_S188 ( )
   (mode_tile "label1" 1)
   (mode_tile "label2" 0)
   (set_tile "DimA" "-")
   (mode_tile "DimA" 1)
   (mode_tile "DimB" 0)
   (set_tile "DimB" ".370"))

  (defun do_O188 ( )
   (mode_tile "label1" 0)
   (mode_tile "label2" 1)
   (mode_tile "DimA" 0)
   (set_tile "DimA" ".250")
   (set_tile "DimB" "-")
   (mode_tile "DimB" 1))

  (defun do_B25 ( )
   (mode_tile "label1" 0)
   (mode_tile "label2" 0)
   (mode_tile "DimA" 0)   
   (set_tile "DimA" ".270")
   (mode_tile "DimB" 0)
   (set_tile "DimB" ".410"))

  (defun do_S25 ( )
   (mode_tile "label1" 1)
   (mode_tile "label2" 0)
   (set_tile "DimA" "-")
   (mode_tile "DimA" 1)
   (mode_tile "DimB" 0)
   (set_tile "DimB" ".470"))

  (defun do_O25 ( )
   (mode_tile "label1" 0)
   (mode_tile "label2" 1)
   (mode_tile "DimA" 0)
   (set_tile "DimA" ".280")
   (set_tile "DimB" "-")
   (mode_tile "DimB" 1))

  (defun do_B312 ( )
   (mode_tile "label1" 0)
   (mode_tile "label2" 0)
   (mode_tile "DimA" 0)   
   (set_tile "DimA" ".300")
   (mode_tile "DimB" 0)
   (set_tile "DimB" ".480"))

  (defun do_S312 ( )
   (mode_tile "label1" 1)
   (mode_tile "label2" 0)
   (set_tile "DimA" "-")
   (mode_tile "DimA" 1)
   (mode_tile "DimB" 0)
   (set_tile "DimB" ".550"))

  (defun do_O312 ( )
   (mode_tile "label1" 0)
   (mode_tile "label2" 1)
   (mode_tile "DimA" 0)
   (set_tile "DimA" ".380")
   (set_tile "DimB" "-")
   (mode_tile "DimB" 1))

  (defun do_B344 ( )
   (mode_tile "label1" 0)
   (mode_tile "label2" 0)
   (mode_tile "DimA" 0)   
   (set_tile "DimA" ".300")
   (mode_tile "DimB" 0)
   (set_tile "DimB" ".500"))

  (defun do_S344 ( )
   (mode_tile "label1" 1)
   (mode_tile "label2" 0)
   (set_tile "DimA" "-")
   (mode_tile "DimA" 1)
   (mode_tile "DimB" 0)
   (set_tile "DimB" ".580"))

  (defun do_O344 ( )
   (mode_tile "label1" 0)
   (mode_tile "label2" 1)
   (mode_tile "DimA" 0)
   (set_tile "DimA" ".420")
   (set_tile "DimA" "-")
   (mode_tile "DimB" 1))

  (defun do_B375 ( )
   (mode_tile "label1" 0)
   (mode_tile "label2" 0)
   (mode_tile "DimA" 0)   
   (set_tile "DimA" ".340")
   (mode_tile "DimB" 0)
   (set_tile "DimB" ".560"))

  (defun do_S375 ( )
   (mode_tile "label1" 1)
   (mode_tile "label2" 0)
   (set_tile "DimA" "-")
   (mode_tile "DimA" 1)
   (mode_tile "DimB" 0)
   (set_tile "DimB" ".620"))

  (defun do_O375 ( )
   (mode_tile "label1" 0)
   (mode_tile "label2" 1)
   (mode_tile "DimA" 0)
   (set_tile "DimA" ".420")
   (set_tile "DimB" "-")
   (mode_tile "DimB" 1))

  (defun do_B438 ( )
   (mode_tile "label1" 0)
   (mode_tile "label2" 0)
   (mode_tile "DimA" 0)   
   (set_tile "DimA" ".400")
   (mode_tile "DimB" 0)
   (set_tile "DimB" ".650"))

  (defun do_S438 ( )
   (mode_tile "label1" 1)
   (mode_tile "label2" 0)
   (set_tile "DimA" "-")
   (mode_tile "DimA" 1)
   (mode_tile "DimB" 0)
   (set_tile "DimB" ".750"))

  (defun do_O438 ( )
   (mode_tile "label1" 0)
   (mode_tile "label2" 1)
   (mode_tile "DimA" 0)
   (set_tile "DimA" ".470")
   (set_tile "DimB" "-")
   (mode_tile "DimB" 1))

  (defun do_B5 ( )
   (mode_tile "label1" 0)
   (mode_tile "label2" 0)
   (mode_tile "DimA" 0)   
   (set_tile "DimA" ".450")
   (mode_tile "DimB" 0)
   (set_tile "DimB" ".740"))

  (defun do_S5 ( )
   (mode_tile "label1" 1)
   (mode_tile "label2" 0)
   (set_tile "DimA" "-")
   (mode_tile "DimA" 1)
   (mode_tile "DimB" 0)
   (set_tile "DimB" ".810"))

  (defun do_O5 ( )
   (mode_tile "label1" 0)
   (mode_tile "label2" 1)
   (mode_tile "DimA" 0)
   (set_tile "DimA" ".520")
   (set_tile "DimB" "-")
   (mode_tile "DimB" 1))


  (defun do_B562 ( )
   (mode_tile "label1" 0)
   (mode_tile "label2" 0)
   (mode_tile "DimA" 0)   
   (set_tile "DimA" ".500")
   (mode_tile "DimB" 0)
   (set_tile "DimB" ".830"))

  (defun do_S562 ( )
   (mode_tile "label1" 1)
   (mode_tile "label2" 0)
   (set_tile "DimA" "-")
   (mode_tile "DimA" 1)
   (mode_tile "DimB" 0)
   (set_tile "DimB" ".870"))

  (defun do_O562 ( )
   (mode_tile "label1" 0)
   (mode_tile "label2" 1)
   (mode_tile "DimA" 0)
   (set_tile "DimA" ".590")
   (set_tile "DimB" "-")
   (mode_tile "DimB" 1))

  (defun do_B594 ( )
   (mode_tile "label1" 0)
   (mode_tile "label2" 0)
   (mode_tile "DimA" 0)   
   (set_tile "DimA" ".530")
   (mode_tile "DimB" 0)
   (set_tile "DimB" ".870"))

  (defun do_S594 ( )
   (mode_tile "label1" 1)
   (mode_tile "label2" 0)
   (set_tile "DimA" "-")
   (mode_tile "DimA" 1)
   (mode_tile "DimB" 0)
   (set_tile "DimB" ".920"))

  (defun do_O594 ( )
   (mode_tile "label1" 0)
   (mode_tile "label2" 1)
   (mode_tile "DimA" 0)
   (set_tile "DimA" ".640")
   (set_tile "DimB" "-")
   (mode_tile "DimB" 1))

  (defun do_B625 ( )
   (mode_tile "label1" 0)
   (mode_tile "label2" 0)
   (mode_tile "DimA" 0)   
   (set_tile "DimA" ".560")
   (mode_tile "DimB" 0)
   (set_tile "DimB" ".920"))

  (defun do_S625 ( )
   (mode_tile "label1" 1)
   (mode_tile "label2" 0)
   (set_tile "DimA" "-")
   (mode_tile "DimA" 1)
   (mode_tile "DimB" 0)
   (set_tile "DimB" ".950"))

  (defun do_O625 ( )
   (mode_tile "label1" 0)
   (mode_tile "label2" 1)
   (mode_tile "DimA" 0)
   (set_tile "DimA" ".640")
   (set_tile "DimB" "-")
   (mode_tile "DimB" 1))

  (defun do_B688 ( )
   (mode_tile "label1" 0)
   (mode_tile "label2" 0)
   (mode_tile "DimA" 0)   
   (set_tile "DimA" ".590")
   (mode_tile "DimB" 0)
   (set_tile "DimB" ".990"))

  (defun do_S688 ( )
   (mode_tile "label1" 1)
   (mode_tile "label2" 0)
   (set_tile "DimA" "-")
   (mode_tile "DimA" 1)
   (mode_tile "DimB" 0)
   (set_tile "DimB" "1.030"))

  (defun do_O688 ( )
   (mode_tile "label1" 0)
   (mode_tile "label2" 1)
   (mode_tile "DimA" 0)
   (set_tile "DimA" ".770")
   (set_tile "DimB" "-")
   (mode_tile "DimB" 1))

  (defun do_B75 ( )
   (mode_tile "label1" 0)
   (mode_tile "label2" 0)
   (mode_tile "DimA" 0)   
   (set_tile "DimA" ".660")
   (mode_tile "DimB" 0)
   (set_tile "DimB" "1.090"))

  (defun do_S75 ( )
   (mode_tile "label1" 1)
   (mode_tile "label2" 0)
   (set_tile "DimA" "-")
   (mode_tile "DimA" 1)
   (mode_tile "DimB" 0)
   (set_tile "DimB" "1.120"))

  (defun do_O75 ( )
   (mode_tile "label1" 0)
   (mode_tile "label2" 1)
   (mode_tile "DimA" 0)
   (set_tile "DimA" ".770")
   (set_tile "DimB" "-")
   (mode_tile "DimB" 1))

  (defun do_B781 ( )
   (mode_tile "label1" 0)
   (mode_tile "label2" 0)
   (mode_tile "DimA" 0)   
   (set_tile "DimA" ".690")
   (mode_tile "DimB" 0)
   (set_tile "DimB" "1.140"))

  (defun do_S781 ( )
   (mode_tile "label1" 1)
   (mode_tile "label2" 0)
   (set_tile "DimA" "-")
   (mode_tile "DimA" 1)
   (mode_tile "DimB" 0)
   (set_tile "DimB" "1.150"))

  (defun do_O781 ( )
   (mode_tile "label1" 0)
   (mode_tile "label2" 1)
   (mode_tile "DimA" 0)
   (set_tile "DimA" ".830")
   (set_tile "DimB" "-")
   (mode_tile "DimB" 1))

  (defun do_B812 ( )
   (mode_tile "label1" 0)
   (mode_tile "label2" 0)
   (mode_tile "DimA" 0)   
   (set_tile "DimA" ".720")
   (mode_tile "DimB" 0)
   (set_tile "DimB" "1.190"))

  (defun do_S812 ( )
   (mode_tile "label1" 1)
   (mode_tile "label2" 0)
   (set_tile "DimA" "-")
   (mode_tile "DimA" 1)
   (mode_tile "DimB" 0)
   (set_tile "DimB" "1.200"))

  (defun do_O812 ( )
   (mode_tile "label1" 0)
   (mode_tile "label2" 1)
   (mode_tile "DimA" 0)
   (set_tile "DimA" ".910")
   (set_tile "DimB" "-")
   (mode_tile "DimB" 1))

  (defun do_B875 ( )
   (mode_tile "label1" 0)
   (mode_tile "label2" 0)
   (mode_tile "DimA" 0)   
   (set_tile "DimA" ".750")
   (mode_tile "DimB" 0)
   (set_tile "DimB" "1.260"))

  (defun do_S875 ( )
   (mode_tile "label1" 1)
   (mode_tile "label2" 0)
   (set_tile "DimA" "-")
   (mode_tile "DimA" 1)
   (mode_tile "DimB" 0)
   (set_tile "DimB" "1.280"))

  (defun do_O875 ( )
   (mode_tile "label1" 0)
   (mode_tile "label2" 1)
   (mode_tile "DimA" 0)
   (set_tile "DimA" ".970")
   (set_tile "DimB" "-")
   (mode_tile "DimB" 1))

  (defun do_B938 ( )
   (mode_tile "label1" 0)
   (mode_tile "label2" 0)
   (mode_tile "DimA" 0)   
   (set_tile "DimA" ".780")
   (mode_tile "DimB" 0)
   (set_tile "DimB" "1.320"))

  (defun do_S938 ( )
   (mode_tile "label1" 1)
   (mode_tile "label2" 0)
   (set_tile "DimA" "-")
   (mode_tile "DimA" 1)
   (mode_tile "DimB" 0)
   (set_tile "DimB" "1.370"))

  (defun do_O938 ( )
   (mode_tile "label1" 0)
   (mode_tile "label2" 1)
   (mode_tile "DimA" 0)
   (set_tile "DimA" ".970")
   (set_tile "DimB" "-")
   (mode_tile "DimB" 1))

  (defun do_B1 ( )
   (mode_tile "label1" 0)
   (mode_tile "label2" 0)
   (mode_tile "DimA" 0)   
   (set_tile "DimA" ".810")
   (mode_tile "DimB" 0)
   (set_tile "DimB" "-"))

  (defun do_S1 ( )
   (mode_tile "label1" 1)
   (mode_tile "label2" 0)
   (set_tile "DimA" "-")
   (mode_tile "DimA" 1)
   (mode_tile "DimB" 0)
   (set_tile "DimB" "1.470"))

  (defun do_O1 ( )
   (mode_tile "label1" 0)
   (mode_tile "label2" 1)
   (mode_tile "DimA" 0)
   (set_tile "DimA" "1.050")
   (set_tile "DimB" "-")
   (mode_tile "DimB" 1))

  (action_tile
    "accept"
    "(done_dialog)")
  (start_dialog)
  (unload_dialog dcl_id)
 )
;
;
;*************************************************************************
;
;       CON_VERT.LSP    Copyright (c) 1994 by   DesignTec
;       Version 1.0                             255 Celia St.
;                                               Boaz, AL 35957
;
;
;       THIS ROUTINE, ALONG WITH ALL FOLLOWING ROUTINES, ARE
;       LICENSED TO SUN TRACE SOFTWARE FOR USE AND INTEGRATION INTO
;       THEIR SOFTWARE.  UNAUTHORIZED USE OR REPRODUCTION OF THESE
;       ROUTINES, IN WHOLE OR IN PART, IS STRICTLY PROHIBITED.  ALL
;       RIGHTS RESERVED.
;
;
;
;       THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESSED OR IMPLIED
;       WARRANTY.  ALL IMPLIED WARRANTIES OF FITNESS FOR ANY PARTICULAR
;       PURPOSE AND OF MERCHANTABILITY ARE HEREBY DISCLAIMED.
;
;
;*************************************************************************
;
(defun init_stuf ()
  (setq what_next 2)                       
  (setq SOURCE "0")
  (setq CONV "0")
  (setq CONV_FROM nil)
  (setq CONV_TO nil)
)
;;
;;
;;
(defun tile_setup ()
  (set_tile "source_value" SOURCE)
  (set_tile "conv_value" CONV)
)
;;
;;
;;
(defun tile_check ()
  (cond
    ((= CONV_FROM_TYPE "metric") (metric_disable))
    ((= CONV_FROM_TYPE "english") (english_disable))
    (t nil)
  )
)  
;; 
;;
;;
(defun metric_disable ()
  (mode_tile "from_inch" 0)
  (mode_tile "from_foot" 0)
  (mode_tile "from_yard" 0)
  (mode_tile "from_mile" 0)
  (mode_tile "from_nmile" 0)
  (mode_tile "from_mm" 0)
  (mode_tile "from_cm" 0)
  (mode_tile "from_meter" 0)
  (mode_tile "from_km" 0)
  (mode_tile "to_inch" 0)
  (mode_tile "to_foot" 0)
  (mode_tile "to_yard" 0)
  (mode_tile "to_mile" 0)
  (mode_tile "to_nmile" 0)  
  (mode_tile "to_mm" 1)
  (mode_tile "to_cm" 1)
  (mode_tile "to_meter" 1)
  (mode_tile "to_km" 1)
  (if (= CONV_TO "mm") (setq CONV_TO nil)
    (if (= CONV_TO "cm") (setq CONV_TO nil)
      (if (= CONV_TO "meter") (setq CONV_TO nil)
	(if (= CONV_TO "km") (setq CONV_TO nil)
	)
      )
    )
  )
)
;;
;;
;;
(defun english_disable ()
  (mode_tile "from_inch" 0)
  (mode_tile "from_foot" 0)
  (mode_tile "from_yard" 0)
  (mode_tile "from_mile" 0)
  (mode_tile "from_nmile" 0)
  (mode_tile "from_mm" 0)
  (mode_tile "from_cm" 0)
  (mode_tile "from_meter" 0)
  (mode_tile "from_km" 0)
  (mode_tile "to_inch" 1)
  (mode_tile "to_foot" 1)
  (mode_tile "to_yard" 1)
  (mode_tile "to_mile" 1)
  (mode_tile "to_nmile" 1)  
  (mode_tile "to_mm" 0)
  (mode_tile "to_cm" 0)
  (mode_tile "to_meter" 0)
  (mode_tile "to_km" 0)
  (if (= CONV_TO "inch") (setq CONV_TO nil)
    (if (= CONV_TO "foot") (setq CONV_TO nil) 
      (if (= CONV_TO "yard") (setq CONV_TO nil)
	(if (= CONV_TO "mile") (setq CONV_TO nil)
	  (if (= CONV_TO "nmile") (setq CONV_TO nil)
	  )
	)
      )
    )
  )
)
;;
;;
;;
(defun start_from (which)
  (cond
    ((= which "from_inch") (setq CONV_FROM "inch")(setq CONV_FROM_TYPE "english"))
    ((= which "from_foot") (setq CONV_FROM "foot")(setq CONV_FROM_TYPE "english"))
    ((= which "from_yard") (setq CONV_FROM "yard")(setq CONV_FROM_TYPE "english"))
    ((= which "from_mile") (setq CONV_FROM "mile")(setq CONV_FROM_TYPE "english"))
    ((= which "from_nmile") (setq CONV_FROM "nmile")(setq CONV_FROM_TYPE "english"))
    ((= which "from_mm") (setq CONV_FROM "mm")(setq CONV_FROM_TYPE "metric"))
    ((= which "from_cm") (setq CONV_FROM "cm")(setq CONV_FROM_TYPE "metric"))
    ((= which "from_meter") (setq CONV_FROM "meter")(setq CONV_FROM_TYPE "metric"))
    ((= which "from_km") (setq CONV_FROM "km")(setq CONV_FROM_TYPE "metric"))
  )                                                                        
  (tile_check)
)
;;
;;
;;
(defun start_to (which)
  (cond
    ((= which "to_inch") (setq CONV_TO "inch"))
    ((= which "to_foot") (setq CONV_TO "foot"))
    ((= which "to_yard") (setq CONV_TO "yard"))
    ((= which "to_mile") (setq CONV_TO "mile"))
    ((= which "to_nmile") (setq CONV_TO "nmile"))
    ((= which "to_mm") (setq CONV_TO "mm"))
    ((= which "to_cm") (setq CONV_TO "cm"))
    ((= which "to_meter") (setq CONV_TO "meter"))
    ((= which "to_km") (setq CONV_TO "km"))
  )                                                                        
)
;;
;;
;;
(defun get_actions ()
  (action_tile "from" "(start_from $value) (do_calc)")
  (action_tile "to" "(start_to $value) (do_calc)")
  (action_tile "source_value" "(setq SOURCE (distof $value 2)) (do_calc)")
  (action_tile "conv_value" "(setq CONV (distof $value 2)) (do_calc)")
)
;;
;;
;;
(defun do_calc ()
  (if  (= CONV_FROM nil)
    (set_tile "error1" "A \"Convert From:\" Unit Must be Selected..")
    (if (= CONV_TO nil)
      (set_tile "error1" "A \"Convert To:\" Unit Must be Selected..")
      (if (= SOURCE nil)
	(set_tile "error1" "The \"Source Value:\" Must be a Non-zero Real Number..")
	(if (= SOURCE "0")
	  (set_tile "error1" "The \"Source Value:\" Must be a Non-zero Real Number..")
	  (progn (set_tile "error1" " ") (conv_calc))
	)  
      )
    )   
  )
)
;;
;;
;;
(defun conv_calc ()
  (cond
    ((= CONV_FROM "inch") (conv_inch))
    ((= CONV_FROM "foot") (conv_foot))
    ((= CONV_FROM "yard") (conv_yard))
    ((= CONV_FROM "mile") (conv_mile))
    ((= CONV_FROM "nmile") (conv_nmile))
    ((= CONV_FROM "mm") (conv_mm))
    ((= CONV_FROM "cm") (conv_cm))
    ((= CONV_FROM "meter") (conv_meter))
    ((= CONV_FROM "km") (conv_km))
  )
  (set_tile "conv_value" (rtos CONV 2))
)
;;
;;
;;
(defun conv_inch ()
  (cond
    ((= CONV_TO "mm") (setq CONV (* SOURCE 25.40)))
    ((= CONV_TO "cm") (setq CONV (* SOURCE 2.540)))
    ((= CONV_TO "meter") (setq CONV (* SOURCE 0.02540)))
    ((= CONV_TO "km") (setq CONV (* SOURCE 0.00002540)))
  )
)
;;
;;
(defun conv_foot ()
  (cond
    ((= CONV_TO "mm") (setq CONV (* SOURCE 304.8)))
    ((= CONV_TO "cm") (setq CONV (* SOURCE 30.48)))
    ((= CONV_TO "meter") (setq CONV (* SOURCE 0.3048)))
    ((= CONV_TO "km") (setq CONV (* SOURCE 0.0003048)))
  )
)
;;
;;
(defun conv_yard ()
  (cond
    ((= CONV_TO "mm") (setq CONV (* SOURCE 914.4)))
    ((= CONV_TO "cm") (setq CONV (* SOURCE 91.44)))
    ((= CONV_TO "meter") (setq CONV (* SOURCE 0.9144)))
    ((= CONV_TO "km") (setq CONV (* SOURCE 0.0009144)))
  )
)
;;
;;
(defun conv_mile ()
  (cond
    ((= CONV_TO "mm") (setq CONV (* SOURCE 1609000)))
    ((= CONV_TO "cm") (setq CONV (* SOURCE 160900)))
    ((= CONV_TO "meter") (setq CONV (* SOURCE 1609)))
    ((= CONV_TO "km") (setq CONV (* SOURCE 1.609)))
  )
)
;;
;;
(defun conv_nmile ()
  (cond
    ((= CONV_TO "mm") (setq CONV (* SOURCE 1853000)))
    ((= CONV_TO "cm") (setq CONV (* SOURCE 185300)))
    ((= CONV_TO "meter") (setq CONV (* SOURCE 1853)))
    ((= CONV_TO "km") (setq CONV (* SOURCE 1.853)))
  )
)
;;
;;
(defun conv_mm ()
  (cond
    ((= CONV_TO "inch") (setq CONV (* SOURCE 0.03937)))
    ((= CONV_TO "foot") (setq CONV (* SOURCE 0.003281)))
    ((= CONV_TO "yard") (setq CONV (* SOURCE 0.001094)))
    ((= CONV_TO "mile") (setq CONV (* SOURCE 0.0000006214)))
    ((= CONV_TO "nmile") (setq CONV (* SOURCE 0.0000005396)))
  )
)
;;
;;
(defun conv_cm ()
  (cond
    ((= CONV_TO "inch") (setq CONV (* SOURCE 0.3937)))
    ((= CONV_TO "foot") (setq CONV (* SOURCE 0.03281)))
    ((= CONV_TO "yard") (setq CONV (* SOURCE 0.01094)))
    ((= CONV_TO "mile") (setq CONV (* SOURCE 0.000006214)))
    ((= CONV_TO "nmile") (setq CONV (* SOURCE 0.000005396)))
  )
)
;;
;;
(defun conv_meter ()
  (cond
    ((= CONV_TO "inch") (setq CONV (* SOURCE 39.37)))
    ((= CONV_TO "foot") (setq CONV (* SOURCE 3.281)))
    ((= CONV_TO "yard") (setq CONV (* SOURCE 1.094)))
    ((= CONV_TO "mile") (setq CONV (* SOURCE 0.0006214)))
    ((= CONV_TO "nmile") (setq CONV (* SOURCE 0.0005396)))
  )
)  
;;
;;
(defun conv_km ()
  (cond
    ((= CONV_TO "inch") (setq CONV (* SOURCE 39370)))
    ((= CONV_TO "foot") (setq CONV (* SOURCE 3281)))
    ((= CONV_TO "yard") (setq CONV (* SOURCE 1094)))
    ((= CONV_TO "mile") (setq CONV (* SOURCE 0.6214)))
    ((= CONV_TO "nmile") (setq CONV (* SOURCE 0.5396)))
  )
)
;;
;;      MAIN ROUTINE
;;
(defun C:CON_VERT (/ DCL_ID SOURCE CONV CONV_TO CONV_FROM CONV_FROM_TYPE)
  (BEGIN)
  (init_stuf)
  (setq DCL_ID (load_dialog "DTOOLS.DCL"))
  (if (not (new_dialog "CON_VERT" DCL_ID)) (exit))
  (tile_setup)
  (get_actions)
  (start_dialog)
  (unload_dialog DCL_ID)
  (princ)
)
;*************************************************************************
(DEFUN C:BREAK1 (/ SZE CLX SZE2 SZE3 START1 END1 ANG ANG2 START2 END2 MID
		  PNT1 PNT2 ANG3 LYR EL ENT)
(SETVAR "CMDECHO" 0)
(BEGIN)
(SETQ SZE (GETVAR "TEXTSIZE"))
(SETQ SZE (* SZE 0.625))
(setq CLX (getvar "CLAYER"))
(SETQ SZE2 (* SZE 2.0))
(SETQ SZE3 (* SZE 1.5))
(SETQ START1 (GETPOINT "\nPick Start Point of Break Line:"))
(SETQ END1 (GETPOINT START1 "\nPick End Point of Break Line:"))
(SETQ ANG (ANGLE END1 START1))
(SETQ ANG2 (ANGLE START1 END1))
(SETQ START2 (POLAR START1 ANG SZE2))
(SETQ END2 (POLAR END1 ANG2 SZE2))
(COMMAND "LINE" START2 END2 "")
(SETQ MID (POLAR END2  ANG (/ (DISTANCE START2 END2) 2.0)))
(SETQ PNT1 (POLAR MID ANG SZE3))
(SETQ PNT2 (POLAR MID (+ ANG PI) SZE3))
(COMMAND "BREAK" PNT1 PNT2)
(SETQ ANG3 (* (/ ANG PI) 180))
(COMMAND "INSERT" "BRK1" MID SZE SZE ANG3)
(SETQ ENT (ENTLAST))
   (SETQ LYR (CDR (ASSOC 8 (ENTGET ENT))))
   (SETQ EL (ENTLAST))
   (COMMAND "EXPLODE" ENT)
   (WHILE (SETQ EN (ENTNEXT EL))
      (PROGN
	 (SETQ ENT (ENTGET EN))
	 (SETQ ENT (SUBST (CONS 8 LYR) (ASSOC 8 ENT) ENT))
	 (ENTMOD ENT)              
	 (SETQ ENT (SUBST (CONS 62 256) (ASSOC 62 ENT) ENT))
	 (ENTMOD ENT)
	 (SETQ EL EN)
      )
   )
(PRIN1)
)
;*************************************************************************
(DEFUN C:BREAK2 (/ SZE CLX SZE2 SZE3 START1 END1 ANG ANG2 START2 END2 MID
		  PNT1 PNT2 ANG3 ENT LYR EL)
(SETVAR "CMDECHO" 0)
(BEGIN)
(SETQ SZE (GETVAR "TEXTSIZE"))
(SETQ SZE (* SZE 0.5))
(setq CLX (getvar "CLAYER"))
(SETQ SZE2 (* SZE 2.0))
(SETQ SZE3 (* SZE 1.5))
(SETQ START1 (GETPOINT "\nPick Start Point of Break Line:"))
(SETQ END1 (GETPOINT START1 "\nPick End Point of Break Line:"))
(SETQ ANG (ANGLE END1 START1))
(SETQ ANG2 (ANGLE START1 END1))
(SETQ START2 (POLAR START1 ANG SZE2))
(SETQ END2 (POLAR END1 ANG2 SZE2))
(COMMAND "LINE" START2 END2 "")
(SETQ MID (POLAR END2  ANG (/ (DISTANCE START2 END2) 2.0)))
(SETQ PNT1 (POLAR MID ANG SZE3))
(SETQ PNT2 (POLAR MID (+ ANG PI) SZE3))
(COMMAND "BREAK" PNT1 PNT2)
(SETQ ANG3 (* (/ ANG PI) 180))
(COMMAND "INSERT" "BRK2" MID SZE SZE ANG3)
(SETQ ENT (ENTLAST))
   (SETQ LYR (CDR (ASSOC 8 (ENTGET ENT))))
   (SETQ EL (ENTLAST))
   (COMMAND "EXPLODE" ENT)
   (WHILE (SETQ EN (ENTNEXT EL))
      (PROGN
	 (SETQ ENT (ENTGET EN))
	 (SETQ ENT (SUBST (CONS 8 LYR) (ASSOC 8 ENT) ENT))
	 (ENTMOD ENT)
	 (SETQ ENT (SUBST (CONS 62 256) (ASSOC 62 ENT) ENT))
	 (ENTMOD ENT)
	 (SETQ EL EN)
      )
   )
(PRIN1)
)
;*************************************************************************
(DEFUN C:BREAK3 (/ SZE CLX SZE2 SZE3 START1 END1 ANG ANG2 START2 END2 MID
		  PNT1 PNT2 ANG3 ENT LYR EL)
(SETVAR "CMDECHO" 0)
(BEGIN)
(SETQ SZE (GETVAR "TEXTSIZE"))
(SETQ SZE (* SZE 0.5))
(setq CLX (getvar "CLAYER"))
(SETQ SZE2 (* SZE 2.0))
(SETQ SZE3 (* SZE 1.5))
(SETQ START1 (GETPOINT "\nPick Start Point of Break Line:"))
(SETQ END1 (GETPOINT START1 "\nPick End Point of Break Line:"))
(SETQ ANG (ANGLE END1 START1))
(SETQ ANG2 (ANGLE START1 END1))
(SETQ START2 (POLAR START1 ANG SZE2))
(SETQ END2 (POLAR END1 ANG2 SZE2))
(COMMAND "LINE" START2 END2 "")
(SETQ MID (POLAR END2  ANG (/ (DISTANCE START2 END2) 2.0)))
(SETQ PNT1 (POLAR MID ANG SZE3))
(SETQ PNT2 (POLAR MID (+ ANG PI) SZE3))
(COMMAND "BREAK" PNT1 PNT2)
(SETQ ANG3 (* (/ ANG PI) 180))
(COMMAND "INSERT" "BRK3" MID SZE SZE ANG3)
(SETQ ENT (ENTLAST))
   (SETQ LYR (CDR (ASSOC 8 (ENTGET ENT))))
   (SETQ EL (ENTLAST))
   (COMMAND "EXPLODE" ENT)
   (WHILE (SETQ EN (ENTNEXT EL))
      (PROGN
	 (SETQ ENT (ENTGET EN))
	 (SETQ ENT (SUBST (CONS 8 LYR) (ASSOC 8 ENT) ENT))
	 (ENTMOD ENT)
	 (SETQ ENT (SUBST (CONS 62 256) (ASSOC 62 ENT) ENT))
	 (ENTMOD ENT)
	 (SETQ EL EN)
      )
   )
(PRIN1)
)
;*************************************************************************
(DEFUN C:CTRIM ( / PNT MRK SZE RAD)
    (setvar "CMDECHO" 0)
    (BEGIN)
    (setq OSX (getvar "OSMODE"))
    (setvar "OSMODE" 512)
    (setq PNT (getpoint "\nPick Location of Tag:"))
    (setq MRK (getstring "\nEnter Mark Text(Two Chrs Max):"))
    (setq SZE (getvar "TEXTSIZE"))
    (setq RAD (+ SZE (/ SZE 4.0)))
    (command "CIRCLE" PNT RAD)
    (setq EL (ENTLAST))
    (command "TRIM" EL "" PNT "")
    (command "ERASE" EL "")
    (command "TEXT" "M" PNT "" "0" MRK)
    (setvar "OSMODE" OSX)
    (PRIN1)
)
;*************************************************************************
(DEFUN C:FLAGAROW (/ SZE1 SZE2 CTR DRCT RAD PNT1 PNT2 PNT3 PNT4 PNT5 PNT6
		    HATCHX LSZE HPNT1 HPNT2 HPNT3 HSCALE DIR1 ENT LYR EL
		    NAME TXT1 TXT2 X Y Y1 Y2 TXTPNT1 TXTPNT2)
(setvar "CMDECHO" 0)
(BEGIN)
(setq SZE1 (getvar "TEXTSIZE"))
(setq SZE2 (* SZE1 2.0))
(setq CTR (getpoint "\nPick Center Point of Flag:"))
(setq DRCT (getangle CTR "\nDirection of Arrow:")) 
(setq RAD (* SZE1 3.0))
(setq PNT1 (polar CTR DRCT RAD))
(setq PNT2 (polar CTR (+ DRCT (/ pi 2.0)) RAD))
(setq PNT3 (polar CTR (+ DRCT pi) RAD))
(setq PNT4 (polar CTR (+ DRCT (* (/ 3.0 2.0) pi)) RAD))
(setq PNT5 (polar CTR (* pi 2.0) RAD))
(setq PNT6 (polar CTR pi RAD))
(command "ARC" PNT4 PNT1 PNT2)
(setq HATCHX (ssadd))
(ssadd (entlast) HATCHX)

(setq LSZE (* SZE1 1.5))
(setq HPNT1 (polar PNT1 DRCT LSZE))
(setq HPNT2 (polar PNT2 (+ DRCT (/ pi 2.0)) LSZE))
(setq HPNT4 (polar PNT4 (+ DRCT (* (/ 3.0 2.0) pi)) LSZE))
(command "LINE" PNT2 HPNT2 "")
(ssadd (entlast) HATCHX)
(command "LINE" HPNT2 HPNT1 "")
(ssadd (entlast) HATCHX)
(command "LINE" HPNT1 HPNT4 "")
(ssadd (entlast) HATCHX)
(command "LINE" HPNT4 PNT4 "")
(ssadd (entlast) HATCHX)
(setq HSCALE (* 0.5 (/ SZE1 8.0)))
(setq DIR1 (* (/ DRCT pi) 180))
(command "HATCH" "U" DIR1 HSCALE "N" HATCHX "")

(SETQ ENT (ENTLAST))
   (SETQ LYR (CDR (ASSOC 8 (ENTGET ENT))))
   (SETQ EL (ENTLAST))
   (COMMAND "EXPLODE" ENT)
   (WHILE (SETQ EN (ENTNEXT EL))
      (PROGN
	 (SETQ ENT (ENTGET EN))
	 (SETQ ENT (SUBST (CONS 8 LYR) (ASSOC 8 ENT) ENT))
	 (ENTMOD ENT)
	 (SETQ ENT (SUBST (CONS 62 256) (ASSOC 62 ENT) ENT))
	 (ENTMOD ENT)
	 (SSADD EN HATCHX)
	 (SETQ EL EN)
      )
   )

(command "ARC" PNT2 PNT3 PNT4)
(ssadd (entlast) HATCHX)
(command "LINE" PNT5 PNT6 "")
(ssadd (entlast) HATCHX)
(setq NAME (strcat "FLG" (substr (rtos (getvar "CDATE") 2 9) 14 15)))
(command "BLOCK" NAME CTR HATCHX "")
(command "INSERT" NAME CTR 1 1 0)

(setq TXT1 (getstring "\nEnter Designation (Or Top Text):"))
(setq TXT2 (getstring "\nEnter Sheet No. (Or Bottom Text):"))
(setq X (car CTR))
(setq Y (car (cdr CTR)))
(setq Y1 (+ Y (* SZE1 1.5)))
(setq Y2 (- Y SZE1))
(setq TXTPNT1 (LIST X Y1))
(setq TXTPNT2 (list X Y2))
(command "TEXT" "M" TXTPNT1 SZE2 "0" TXT1)
(command "TEXT" "M" TXTPNT2 SZE1 "0" TXT2)
(setvar "TEXTSIZE" SZE1)
(PRIN1)
)
;*************************************************************************
(DEFUN C:FLAGTITL (/ SZE1 SZE2 CTR RAD PNT5 PNT6 TXT1 TXT2 X Y Y1 Y2
		    TXTPNT1 TXTPNT2)
(setvar "CMDECHO" 0)
(BEGIN)
(setq SZE1 (getvar "TEXTSIZE"))
(setq SZE2 (* SZE1 2.0))
(setq CTR (getpoint "\nPick Center Point of Title Flag:"))
(setq RAD (* SZE1 3.0))
(setq PNT5 (polar CTR (* pi 2.0) RAD))
(setq PNT6 (polar CTR pi RAD))

(command "CIRCLE" CTR RAD)
(command "LINE" PNT5 PNT6 "")

(setq TXT1 (getstring "\nEnter Designation (Or Top Text):"))
(setq TXT2 (getstring "\nEnter Sheet No. (Or Bottom Text):"))
(setq X (car CTR))
(setq Y (car (cdr CTR)))
(setq Y1 (+ Y (* SZE1 1.5)))
(setq Y2 (- Y SZE1))
(setq TXTPNT1 (LIST X Y1))
(setq TXTPNT2 (list X Y2))
(command "TEXT" "M" TXTPNT1 SZE2 "0" TXT1)
(command "TEXT" "M" TXTPNT2 SZE1 "0" TXT2)
(setvar "TEXTSIZE" SZE1)
(PRIN1)
)
;*************************************************************************
;;
;;      SETUP ROUTINE
;;
(defun C:DL_SETUP ( / ARROW_T TXTBOX_T DIRECT_T)
  (dl_init_stuf)
  (setq DCL_ID (load_dialog "DTOOLS.DCL"))
  (if (not (new_dialog "DLEADERS" DCL_ID)) (exit))
  (dl_tile_setup)
  (dl_get_actions)
  (start_dialog)
  (unload_dialog DCL_ID)
  (princ)
)
;;
;;
(defun dl_init_stuf ()
  (setq what_next 5)
  (if (= ARROW nil) (setq ARROW "ar_none") (setq ARROW_T ARROW))
  (if (= TXTBOX nil) (setq TXTBOX "tx_none") (setq TXTBOX_T TXTBOX))
  (if (= DIRECT nil) (setq DIRECT "from_feat") (setq DIRECT_T DIRECT))
;  (setq AR_SIZE_T AR_SIZE)
;  (setq TX_SIZE_T TX_SIZE)
)
;;
;;
(defun dl_tile_setup ()
  (set_tile "arrow" ARROW)
  (set_tile "text_box" TXTBOX)
  (set_tile "direction" DIRECT)
  (setq X (dimx_tile "image"))
  (setq Y (dimy_tile "image"))

  (show_slide)
;  (set_tile "ar_size" AR_SIZE)
;  (set_tile "tx_size" TX_SIZE)
)
;;
;;
(defun dl_get_actions ()
  (action_tile "arrow" "(setq ARROW $value) (show_slide)")
  (action_tile "text_box" "(setq TXTBOX $value) (show_slide)")
  (action_tile "direction" "(setq DIRECT $value) (show_slide)")
;  (action_tile "ar_size" "(setq AR_SIZE $value) (show_slide)")
;  (action_tile "tx_size" "(setq TX_SIZE $value) (show_slide)")
  (action_tile "cancel" "(leader_abort)")
)         
;;
;;
(defun leader_abort ()
  (setq ARROW ARROW_T)
  (setq TXTBOX TXTBOX_T)
  (setq DIRECT DIRECT_T)
;  (setq AR_SIZE AR_SIZE_T)
;  (setq TX_SIZE TX_SIZE_T)
  (exit)
  (princ)
)
;;
;;
(defun show_slide ( / AR TX DR)
  (cond
    ((= ARROW "ar_none") (setq AR "0_"))
    ((= ARROW "ar_tic") (setq AR "1_"))
    ((= ARROW "ar_arc1") (setq AR "2_"))
    ((= ARROW "ar_arc2") (setq AR "3_"))
    ((= ARROW "ar_mech") (setq AR "4_"))
    ((= ARROW "ar_dot") (setq AR "5_"))
  )
  (cond
    ((= TXTBOX "tx_none") (setq TX "0_"))
    ((= TXTBOX "tx_circ") (setq TX "1_"))
    ((= TXTBOX "tx_sqar") (setq TX "2_"))
    ((= TXTBOX "tx_dmnd") (setq TX "3_"))
    ((= TXTBOX "tx_hex") (setq TX "4_"))
    ((= TXTBOX "tx_elps") (setq TX "5_"))
  )
  (cond
    ((= DIRECT "from_feat") (setq DR "1"))
    ((= DIRECT "from_txt") (setq DR "2"))
  )
  (setq SLIDE (strcat "DLEADERS(" AR TX DR ")"))
  (start_image "image")
  (fill_image 0 0 X Y -2)
  (slide_image 0 0 X Y SLIDE)
  (end_image)
)
;;
;;      MAIN ROUTINE
;;
(defun C:DLEADERS ( / ORX SNX SZE RAD PA PB PC)
  (BEGIN)
  (cond
    ((= ARROW nil) (C:DL_SETUP))
    ((= TXTBOX nil) (C:DL_SETUP))
    ((= DIRECT nil) (C:DL_SETUP))
  )
  (if (= DIRECT "from_feat")
  
    (progn  (setvar "cmdecho" 0)
	    (setq ORX (getvar "orthomode"))
	    (setq SNX (getvar "snapmode"))
	    (setq SZE (getvar "TEXTSIZE"))
	    (setq RAD (+ SZE (/ SZE 4.0)))
	    (setvar "snapmode" 0)
	    (setvar "orthomode" 0)
	    (setq PA (getpoint "\nStart of Leader < at Feature > : "))
	    (setq PB (getpoint PA "\nEnd of Leader Leg : "))
	    (command "line" PA PB "")
	    (setvar "orthomode" 1)
	    (setq PC (getpoint PB "\nEnd of Leader < at Text Location > : "))
	    (command "line" PB PC "")
	    (setq MRK (getstring "\nEnter Text < two characters only > : "))
	    (cond
	      ((= ARROW "ar_none") (setq NONE 1))
	      ((= ARROW "ar_tic") (command "insert" "ar_tic" PA SZE SZE PB))
	      ((= ARROW "ar_arc1") (command "insert" "ar_arc1" PA SZE SZE PB))
	      ((= ARROW "ar_arc2") (command "insert" "ar_arc2" PA SZE SZE PB))
	      ((= ARROW "ar_mech") (command "insert" "ar_mech" PA SZE SZE PB))
	      ((= ARROW "ar_dot") (command "insert" "ar_dot" PA SZE SZE PB))
	    )   
	    (cond 
	      ((= TXTBOX "tx_none") (draw_tx_none))
	      ((= TXTBOX "tx_circ") (draw_tx_circ))
	      ((= TXTBOX "tx_sqar") (draw_tx_sqar))
	      ((= TXTBOX "tx_dmnd") (draw_tx_dmnd))
	      ((= TXTBOX "tx_hex") (draw_tx_hex))
	      ((= TXTBOX "tx_elps") (draw_tx_elps))
	    )
	    (command "text" "m" PC "" "0" MRK)
	    (setvar "snapmode" SNX)
	    (setvar "orthomode" ORX)
    )       
    (progn  (setvar "cmdecho" 0)
	    (setq ORX (getvar "orthomode"))
	    (setq SNX (getvar "snapmode"))
	    (setq SZE (getvar "TEXTSIZE"))
	    (setq RAD (+ SZE (/ SZE 4.0)))
	    (setvar "snapmode" 0)
	    (setvar "orthomode" 1)
	    (setq PC (getpoint "\nStart of Leader < at Text Location > : "))
	    (setq PB (getpoint PC "\nEnd of Leader Leg : "))
	    (command "line" PC PB "")
	    (setvar "orthomode" 0)
	    (setq PA (getpoint PB "\n End of Leader < at Feature > : "))
	    (command "line" PB PA "")
	    (setq MRK (getstring "\nEnter Text < two characters only > : "))
	    (cond
	      ((= ARROW "ar_none") (setq NONE 1))
	      ((= ARROW "ar_tic") (command "insert" "ar_tic" PA SZE SZE PB))
	      ((= ARROW "ar_arc1") (command "insert" "ar_arc1" PA SZE SZE PB))
	      ((= ARROW "ar_arc2") (command "insert" "ar_arc2" PA SZE SZE PB))
	      ((= ARROW "ar_mech") (command "insert" "ar_mech" PA SZE SZE PB))
	      ((= ARROW "ar_dot") (command "insert" "ar_dot" PA SZE SZE PB))
	    )            
	    (cond 
	      ((= TXTBOX "tx_none") (draw_tx_none))
	      ((= TXTBOX "tx_circ") (draw_tx_circ))
	      ((= TXTBOX "tx_sqar") (draw_tx_sqar))
	      ((= TXTBOX "tx_dmnd") (draw_tx_dmnd))
	      ((= TXTBOX "tx_hex") (draw_tx_hex))
	      ((= TXTBOX "tx_elps") (draw_tx_elps))
	    )
	    (command "text" "m" PC "" "0" MRK)
	    (setvar "snapmode" SNX)
	    (setvar "orthomode" ORX)
    )
  )
  (princ)
)
;;
;;      END MAIN ROUTINE
;;
(defun  draw_tx_none ()
  (command "circle" PC RAD)
  (command "trim" "l" "" PC "")
  (command "erase" "l" "")
)    
;;
;;
(defun draw_tx_circ ()
  (command "circle" PC RAD)
  (command "trim" "l" "" PC "")
)
;;
;;
(defun draw_tx_sqar ()
  (command "polygon" "4" PC "C" RAD)
  (command "trim" "l" "" PC "")
)
;;
;;
(defun draw_tx_dmnd ()
  (command "polygon" "4" PC "c" RAD)
  (command "rotate" "l" "" PC "45")
  (command "trim" "l" "" PC "")
)
;;
;;
(defun draw_tx_hex ()
  (command "polygon" "6" PC "c" RAD)
  (command "trim" "l" "" PC "")
)
;;
;;
(defun draw_tx_elps ( / EX EY EX1 EX2 EPNT1 EPNT2)
  (setq EX (car PC))
  (setq EY (car (cdr PC)))
  (setq EX1 (- EX (* SZE 1.5)))
  (setq EX2 (+ EX (* SZE 1.5)))
  (setq EPNT1 (list EX1 EY))
  (setq EPNT2 (list EX2 EY))
  (command "ellipse" EPNT1 EPNT2 SZE)
  (command "trim" "l" "" PC "")
)
;;
;;
;;;END DTOOLS========================================

